/*
 *	  Binary Arithmetic Corder Function Header  (BinArCodec.h)
 */
/* This code was obtained from Lehigh University/Vector Vision, Inc.. 
It was originally developed by OKI. 
Dr. Hongqiao Sun/Weiping integrated it to the Lehigh/VVI software. 

The copyrights or credits should belong to the following people and companies:

Zhixiong Wu and Yoshihiro Ueda of OKI,
Hongqiao Sun of Vector Vision,
Weiping Li of Lehigh University,

Minor modifications was made by Shipeng Li to integrated it to Sarnoff's SOL
software.
*/
#ifndef _BINARCODEC_H_
#define _BINARCODEC_H_
#define		CODE_BITS		32
#define 	HALF			((unsigned) 1 << (CODE_BITS-1))
#define 	QUARTER			((unsigned) 1 << (CODE_BITS-2))
#define		BSBUFSIZE		512

#define		MAXHEADING		8
#define		MAXMIDDLE		16
#define		MAXTRAILING		8

struct arcodec {
    unsigned int L; /* lower bound */
    unsigned int R; /* code range */
    unsigned int V; /* current code value */
    unsigned int arpipe;
    int	bits_to_follow; /* follow bit count */
    int	first_bit;
    int	nzeros;
    int	nonzero;
    int	nzerosf;
    int	extrabits;
};

struct armodel {
    int	type;
    int	ctx_num;
    int	adapt;
    unsigned int *table;
    unsigned int *c0;
    unsigned int *cnt;
};

typedef	struct arcodec ArCoder;	
typedef	struct arcodec ArDecoder;
typedef	struct armodel ArModel;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/* shape/src/BinArCodec.c */
void  	BinArCodeSymbol (	ArCoder *coder,
			BSS *bitstream,
			unsigned char bit,
			ArModel *model,
			int ctx
	);
unsigned char  	BinArDecodeSymbol (	ArDecoder *decoder,
			ArModel *model,
			int ctx
	);

void  	StartArCoder_Still (	ArCoder *coder
	);
void  	StopArCoder_Still (	ArCoder *coder,
			BSS *bitstream
	);
void  	ArCodeSymbol_Still (	ArCoder *coder,
			BSS *bitstream,
			unsigned char bit,
			unsigned int c0
	);
void  	EncRenormalize (	ArCoder *coder,
			BSS *bitstream
	);
void  	BitByItself_Still (	int bit,
			ArCoder *coder,
			BSS *bitstream
	);
void  	BitPlusFollow_Still (	int bit,
			ArCoder *coder,
			BSS *bitstream
	);
void  	BitstreamPutBit_Still (	int bit,
			BSS *bitstream
	);
void  	StartArDecoder_Still (	ArDecoder *decoder
	);
void  	StopArDecoder_Still (	ArDecoder *decoder
	);
unsigned char  	ArDecodeSymbol_Still (	ArDecoder *decoder,
			unsigned int c0
	);
void  	AddNextInputBit_Still (	ArDecoder *decoder
	);
void  	DecRenormalize (	ArDecoder *decoder
	);
void  	InitBitstream (	int flag,
			BSS *bitstream
	);
int  	ByteAlignmentEnc (
	);
int  	ByteAlignmentDec (
	);
void  	PutBitstoStream (	int bits,
			unsigned int code,
			BSS *bitstream
	);
void  	BitstreamFlushBits_Still (	int i
	);
int  	BitstreamLookBit (	int pos
	);
unsigned int  	LookBitsFromStream (	int bits
	);
unsigned int  	LookBitsFromStream1 (	int bits
	);
unsigned int  	GetBitsFromStream (	int bits
	);
void  	BitStreamCopy (	int cnt,
			BSS *bitstream1,
			BSS *bitstream2
	);
void  	BitstreamFlushBitsCopy (	int i,
			BSS *bitstream
	);
int  	BitstreamLookBitCopy (	int pos,
			BSS *bitstream
	);
unsigned int  	LookBitsFromStreamCopy (	int bits,
			BSS *bitstream
	);
unsigned int  	GetBitsFromStreamCopy (	int bits,
			BSS *bitstream
	);
void  	BitStreamMerge (	int cnt,
			BSS *bitstream
	);
void  PutBitstoStreamMerge(int bits,unsigned int code);
#ifdef __cplusplus
}
#endif /* __cplusplus  */ 
#endif /* _BINARCODEC_H_  */ 

