/* This code was obtained from Lehigh University/Vector Vision, Inc.. 
It was originally developed by OKI. 
Dr. Hongqiao Sun/Weiping integrated it to the Lehigh/VVI software. 

The copyrights or credits should belong to the following people and companies:

Zhixiong Wu and Yoshihiro Ueda of OKI,
Hongqiao Sun of Vector Vision,
Weiping Li of Lehigh University,

Minor modifications was made by Shipeng Li to integrated it to Sarnoff's SOL
software.
*/
#ifndef _ShapeCommon_H
#define _ShapeCommon_H
typedef struct BitStreamStructure          BSS;

struct BitStreamStructure {
    unsigned char *bs;
    unsigned char *ptr;
    unsigned int  cnt;
    unsigned int  res;
};

typedef struct Shape_Block_Information     SBI;

struct Shape_Block_Information {
    int	block_size;        /* shape block size */
    int	block_num_hor;     /* number of horizontal blocks */
    int	block_num_ver;     /* number of vertical blocks	*/
    int	change_CR_disable; /* disable the change of CR value */
    int	alphaTH;           /* alpha degradation threshold */
#if 0
    int	**x_ref;           /* x start position id */
    int	**y_ref;           /* y start position id */
#endif
    int	**shape_mode;      /* in/stradle/out of TO */
    int	**CR;              /* shape degradation rate */
    int	**ST;              /* shape coding direction */

    BSS *BitStream;        /* shape info bitstream */
    int	BitStream_Length;  /* shape bit stream length */
};
 

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/* shape/src/ShapeCommon.c */
void  	UpSampling_Still (	int x,
			int y,
			int blkn,
			int cr,
			int blkx,
			unsigned char **buff,
			unsigned char **data,
			unsigned char **shape
	);
void  	AdaptiveUpSampling (	unsigned char **BABdown,
			unsigned char **BABresult,
			int sub_size
	);
void  	DownSampling_Still (	unsigned char **buff,
			unsigned char **data,
			int b_size,
			int s_size
	);
void  	AddBorderToBAB (int blkx,
			int blky,
			int blksize,
			int cr_size,
			int MAX_blkx,
			unsigned char **BABinput,
			unsigned char **BABresult,
			unsigned char **shape
	);

#ifdef __cplusplus
}
#endif /* __cplusplus  */ 
#endif /* _ShapeCommon_H  */ 
