/* $Id: default.h,v 1.7 1998/02/20 21:14:23 hjlee Exp $ */
/****************************************************************************/
/*   MPEG4 Visual Texture Coding (VTC) Mode Software                        */
/*                                                                          */
/*   This software was developed by                                         */
/*   Sarnoff Coporation                   and    Texas Instruments          */
/*   Iraj Sodagar   (iraj@sarnoff.com)           Jie Liang (liang@ti.com)   */
/*   Hung-Ju Lee    (hjlee@sarnoff.com)                                     */
/*   Paul Hatrack   (hatrack@sarnoff.com)                                   */
/*   Shipeng Li     (shipeng@sarnoff.com)                                   */
/*   Bing-Bing Chai (bchai@sarnoff.com)                                     */
/*                                                                          */
/* In the course of development of the MPEG-4 standard. This software       */
/* module is an implementation of a part of one or more MPEG-4 tools as     */
/* specified by the MPEG-4 standard.                                        */
/*                                                                          */
/* The copyright of this software belongs to ISO/IEC. ISO/IEC gives use     */
/* of the MPEG-4 standard free license to use this  software module or      */
/* modifications thereof for hardware or software products claiming         */
/* conformance to the MPEG-4 standard.                                      */
/*                                                                          */
/* Those intending to use this software module in hardware or software      */
/* products are advised that use may infringe existing  patents. The        */
/* original developers of this software module and their companies, the     */
/* subsequent editors and their companies, and ISO/IEC have no liability    */
/* and ISO/IEC have no liability for use of this software module or         */
/* modification thereof in an implementation.                               */
/*                                                                          */
/* Permission is granted to MPEG memebers to use, copy, modify,             */
/* and distribute the software modules ( or portions thereof )              */
/* for standardization activity within ISO/IEC JTC1/SC29/WG11.              */
/*                                                                          */
/* Copyright (C) 1998  Sarnoff Coporation and Texas Instruments             */ 
/****************************************************************************/

/************************************************************/
/*     Sarnoff Very Low Bit Rate Still Image Coder          */
/*     Copyright 1995, 1996, 1997, 1998 Sarnoff Corporation */
/************************************************************/

/* Default Analysis filters -- odd symmetric */
short DefaultAnalysisLPInt[9]= {3, -6, -16, 38, 90, 38, -16, -6, 3};
short DefaultAnalysisHPInt[3]= {-32, 64, -32};
FILTER DefaultAnalysisFilterInt={
  ODD_SYMMETRIC,
  INT_TYPE,
  3,
  9,
  DefaultAnalysisHPInt,
  DefaultAnalysisLPInt,
  128
};

double DefaultAnalysisLPDbl[9]= { 0.03314563036812,  -0.06629126073624,  
			      -0.17677669529665,   0.41984465132952, 
			      0.99436891104360,   0.41984465132952,  
			      -0.17677669529665,  -0.06629126073624, 
			      0.03314563036812 };

double DefaultAnalysisHPDbl[3]= { -0.35355339059327,   0.70710678118655,  
			      -0.35355339059327 };

FILTER DefaultAnalysisFilterDbl={
  ODD_SYMMETRIC,
  DBL_TYPE,
  3,
  9,
  DefaultAnalysisHPDbl,
  DefaultAnalysisLPDbl,
  1
};

/* Default Synthesis filters - odd symmtric*/
short DefaultSynthesisHPInt[9]= {3, 6, -16, -38, 90, -38, -16, 6, 3};
short DefaultSynthesisLPInt[3]= {32, 64, 32};
FILTER DefaultSynthesisFilterInt={
  ODD_SYMMETRIC,
  INT_TYPE,
  9,
  3,
  DefaultSynthesisHPInt,
  DefaultSynthesisLPInt,
  128
};

double DefaultSynthesisHPDbl[9]={ 0.03314563036812,  0.06629126073624, 
				  -0.17677669529665,  -0.41984465132952, 
				  0.99436891104360,  -0.41984465132952, 
				  -0.17677669529665,  0.06629126073624, 
				  0.03314563036812 };

double DefaultSynthesisLPDbl[3]= { 0.35355339059327,   0.70710678118655,  
				   0.35355339059327 };


FILTER DefaultSynthesisFilterDbl={
  ODD_SYMMETRIC,
  DBL_TYPE,
  9,
  3,
  DefaultSynthesisHPDbl,
  DefaultSynthesisLPDbl,
  1
};

/* Default Even Symmetric Analysis filters */
short DefaultEvenAnalysisLPInt[12]= {-5, 15, 19, -97, -26, 350, 350, -26, 
				     -97, 19, 15, -5};
short DefaultEvenAnalysisHPInt[4]= {64, -192, 192, -64};
FILTER DefaultEvenAnalysisFilterInt={
  EVEN_SYMMETRIC,
  INT_TYPE,
  4,
  12,
  DefaultEvenAnalysisHPInt,
  DefaultEvenAnalysisLPInt,
  512
};

double DefaultEvenAnalysisLPDbl[12]= { -0.01381067932005,   0.04143203796015,   
			      0.05248058141619,  -0.26792717880897,   
			      -0.07181553246426,   0.96674755240348,  
			      0.96674755240348,  -0.07181553246426,  
			      -0.26792717880897,   0.05248058141619, 
			      0.04143203796015,  -0.01381067932005};

double DefaultEvenAnalysisHPDbl[12]= { 0.17677669529664,  -0.53033008588991,   
			     0.53033008588991,  -0.17677669529664};

FILTER DefaultEvenAnalysisFilterDbl={
  EVEN_SYMMETRIC,
  DBL_TYPE,
  4,
  12,
  DefaultEvenAnalysisHPDbl,
  DefaultEvenAnalysisLPDbl,
  1
};

/* Default Even Symmetric Synthesis filters */
short DefaultEvenSynthesisHPInt[12]= {5, 15, -19, -97, 26, 350, -350, -26, 
				      97, 19, -15, -5};
short DefaultEvenSynthesisLPInt[4]= {64, 192, 192, 64};
FILTER DefaultEvenSynthesisFilterInt={
  EVEN_SYMMETRIC,
  INT_TYPE,
  12,
  4,
  DefaultEvenSynthesisHPInt,
  DefaultEvenSynthesisLPInt,
  512
};

double DefaultEvenSynthesisHPDbl[12]={ 0.01381067932005,   0.04143203796015,
				       -0.05248058141619,  -0.26792717880897,  
				       0.07181553246426,   0.96674755240348,  
				       -0.96674755240348,  -0.07181553246426,    
				       0.26792717880897,   0.05248058141619,  
				       -0.04143203796015,  -0.01381067932005};


double DefaultEvenSynthesisLPDbl[4]= { 0.17677669529664,   0.53033008588991,  
				       0.53033008588991,   0.17677669529664};


FILTER DefaultEvenSynthesisFilterDbl={
  EVEN_SYMMETRIC,
  DBL_TYPE,
  12,
  4,
  DefaultEvenSynthesisHPDbl,
  DefaultEvenSynthesisLPDbl,
  1
};


/* -------  the following are symmetric filters available from SOL -------- */


/********/
/* Haar */
/********/
double haar_lo[2] = { .707107, .707107 };
double haar_hi[2] = { -.707107, .707107 };
double haar_hi_syn[2] = { .707107, -.707107 };

FILTER HaarAna={
  EVEN_SYMMETRIC,
  DBL_TYPE,
  2,
  2,
  haar_hi,
  haar_lo,
  1
};

FILTER HaarSyn={
  EVEN_SYMMETRIC,
  DBL_TYPE,
  2,
  2,
  haar_hi_syn,
  haar_lo,
  1
};
  

/****************************/
/* QMF9, floating precision */
/****************************/
double qmf9_lo[9] = { 0.028213, -0.060386, -0.073878, 0.41394, 0.798422,
			     0.41394, -0.073878, -0.060386, 0.028213};
double qmf9_hi[9] = { 0.028213, 0.060386, -0.073878, -0.41394, 0.798422,
			     -0.41394, -0.073878, 0.060386, 0.028213};


FILTER qmf9Ana={
  ODD_SYMMETRIC,
  DBL_TYPE,
  9,
  9,
  qmf9_hi,
  qmf9_lo,
  1
};

FILTER  qmf9Syn={
  ODD_SYMMETRIC,
  DBL_TYPE,
  9,
  9,
  qmf9_hi,
  qmf9_lo,
  1
};


/**************************/
/* QMF9, double precision */
/**************************/
double qmf9a_lo[9] = { 0.02821356056934, -0.06040106124895, 
                              -0.07387851649837, 0.41395445184223,  
                              0.79843669304460,  0.41395445184223, 
                              -0.07387851649837, -0.06040106124895,
                              0.02821356056934};
double qmf9a_hi[9] = { 0.02821356056934,  0.06040106124895, 
                              -0.07387851649837, -0.41395445184223,  
                              0.79843669304460,  -0.41395445184223, 
                              -0.07387851649837, 0.06040106124895,  
                              0.02821356056934};

FILTER qmf9aAna={
  ODD_SYMMETRIC,
  DBL_TYPE,
  9,
  9,
  qmf9a_hi,
  qmf9a_lo,
  1
};

FILTER  qmf9aSyn={
  ODD_SYMMETRIC,
  DBL_TYPE,
  9,
  9,
  qmf9a_hi,
  qmf9a_lo,
  1
};




/*********/
/* fpr53 */
/*********/
double fpr53_lo_ana[5] = {-0.1767766953,0.3535533906,1.060660172,
			          0.3535533906,-0.1767766953};
double fpr53_hi_ana[3] = { -0.3535533906,0.7071067812,-0.3535533906 };

double fpr53_lo_syn[3] = { 0.3535533906,0.7071067812,0.3535533906 };
double fpr53_hi_syn[5] = {-0.1767766953,-0.3535533906,1.060660172,
                                 -0.3535533906,-0.1767766953};

FILTER fpr53Ana ={
  ODD_SYMMETRIC,
  DBL_TYPE,
  3,
  5,
  fpr53_hi_ana,
  fpr53_lo_ana,
  1
};

FILTER fpr53Syn ={
  ODD_SYMMETRIC,
  DBL_TYPE,
  5,
  3,
  fpr53_hi_syn,
  fpr53_lo_syn,
  1
};



/**********/
/* fpr53a */
/**********/
double fpr53a_lo_ana[5] = {-0.15713836263467, 0.31427672526933, 
			    0.94283017598577, 0.31427672526933, 
			   -0.15713836263467};
double fpr53a_hi_ana[3] = {-0.35355339059327, 0.70710678118655, 
			   -0.35355339059327};

double fpr53a_lo_syn[3] ={ 0.39773864863086, 0.79547729726172, 
                                  0.39773864863086};
double fpr53a_hi_syn[5] = {-0.17677669530336, -0.35355339060673,  
                                  1.06066017202018, -0.35355339060673, 
                                  -0.17677669530336};

FILTER fpr53aAna ={
  ODD_SYMMETRIC,
  DBL_TYPE,
  3,
  5,
  fpr53a_hi_ana,
  fpr53a_lo_ana,
  1
};

FILTER fpr53aSyn ={
  ODD_SYMMETRIC,
  DBL_TYPE,
  5,
  3,
  fpr53a_hi_syn,
  fpr53a_lo_syn,
  1
};




/*********/
/* ASF93 */
/*********/
double asf93_lo_ana[9]= { 0.02828252799447, -0.05656505598894, 
			  -0.15084014930386, 0.35824535459664, 
			  0.84847583983416, 0.35824535459664, 
			  -0.15084014930386, -0.05656505598894, 
			  0.02828252799447};

double asf93_hi_ana[3]= {-0.41434591710792, 0.82869183421585, 
			 -0.41434591710792};

double asf93_lo_syn[3]= { 0.41434591710792, 0.82869183421585, 
			  0.41434591710792};

double asf93_hi_syn[9]= { 0.02828252799447, 0.05656505598894, 
			  -0.15084014930386, -0.35824535459664, 
			  0.84847583983416, -0.35824535459664, 
			  -0.15084014930386, 0.05656505598894, 
			  0.02828252799447};

FILTER asd93Ana ={
  ODD_SYMMETRIC,
  DBL_TYPE,
  3,
  9,
  asf93_hi_ana,
  asf93_lo_ana,
  1
};

FILTER asd93Syn ={
  ODD_SYMMETRIC,
  DBL_TYPE,
  9,
  3,
  asf93_hi_syn,
  asf93_lo_syn,
  1
};







