/* $Id: bitpack.h,v 1.12 1998/02/20 21:14:36 hjlee Exp $ */
/****************************************************************************/
/*   MPEG4 Visual Texture Coding (VTC) Mode Software                        */
/*                                                                          */
/*   This software was developed by                                         */
/*   Sarnoff Coporation                   and    Texas Instruments          */
/*   Iraj Sodagar   (iraj@sarnoff.com)           Jie Liang (liang@ti.com)   */
/*   Hung-Ju Lee    (hjlee@sarnoff.com)                                     */
/*   Paul Hatrack   (hatrack@sarnoff.com)                                   */
/*   Shipeng Li     (shipeng@sarnoff.com)                                   */
/*   Bing-Bing Chai (bchai@sarnoff.com)                                     */
/*                                                                          */
/* In the course of development of the MPEG-4 standard. This software       */
/* module is an implementation of a part of one or more MPEG-4 tools as     */
/* specified by the MPEG-4 standard.                                        */
/*                                                                          */
/* The copyright of this software belongs to ISO/IEC. ISO/IEC gives use     */
/* of the MPEG-4 standard free license to use this  software module or      */
/* modifications thereof for hardware or software products claiming         */
/* conformance to the MPEG-4 standard.                                      */
/*                                                                          */
/* Those intending to use this software module in hardware or software      */
/* products are advised that use may infringe existing  patents. The        */
/* original developers of this software module and their companies, the     */
/* subsequent editors and their companies, and ISO/IEC have no liability    */
/* and ISO/IEC have no liability for use of this software module or         */
/* modification thereof in an implementation.                               */
/*                                                                          */
/* Permission is granted to MPEG memebers to use, copy, modify,             */
/* and distribute the software modules ( or portions thereof )              */
/* for standardization activity within ISO/IEC JTC1/SC29/WG11.              */
/*                                                                          */
/* Copyright (C) 1998  Sarnoff Coporation and Texas Instruments             */ 
/****************************************************************************/

/************************************************************/
/*     Sarnoff Very Low Bit Rate Still Image Coder          */
/*     Copyright 1995, 1996, 1997, 1998 Sarnoff Corporation */
/************************************************************/

/************************************************************/
/*  Filename: bitpack.h                                     */
/*  Author: Bing-Bing CHai                                  */
/*  Date: Dec. 24, 1997                                     */
/*                                                          */
/*  Descriptions:                                           */
/*      This file is the header file for file_io.h          */
/************************************************************/

#ifndef _BIT_PACK_
#define _BIT_PACK_

/* flag to turn on stuffing bits to prevent start code emulation. */
/* ThisStuffing bits didn't exist in original SOL                 */
#define STUFF 1

extern void init_bit_packing_fp(FILE *fp,int clearByte);
extern int get_bit_rate();
extern void flush_bytes();
/* extern void align_byte(); */
extern int  align_byte();
extern void emit_bits(unsigned int code, int size);
extern void flush_bits ();
extern void flush_bits_zeros ();
extern int put_param(int value, int nbits);
extern int nextinputbit();
extern int get_X_bits(int nbits);
extern int get_param(int nbits);
extern void unget_X_bytes(int n);
extern void restore_arithmetic_offset(int bits_to_go);
extern unsigned int LookBitsFromStream (int n);
extern int get_allbits (char *buffer);
extern int Is_startcode (long startcode);
void emit_bits_checksc(unsigned int code, int size);
void emit_bits_checksc_init();
void get_X_bits_checksc_init();
int get_X_bits_checksc(int nbits);
int get_allbits_checksc (char *buffer);
int align_byte_checksc ();

#endif
