/* $Id: comp_en_de.c,v 1.5 1998/02/20 21:14:37 hjlee Exp $ */
/****************************************************************************/
/*   MPEG4 Visual Texture Coding (VTC) Mode Software                        */
/*                                                                          */
/*   This software was developed by                                         */
/*   Sarnoff Coporation                   and    Texas Instruments          */
/*   Iraj Sodagar   (iraj@sarnoff.com)           Jie Liang (liang@ti.com)   */
/*   Hung-Ju Lee    (hjlee@sarnoff.com)                                     */
/*   Paul Hatrack   (hatrack@sarnoff.com)                                   */
/*   Shipeng Li     (shipeng@sarnoff.com)                                   */
/*   Bing-Bing Chai (bchai@sarnoff.com)                                     */
/*                                                                          */
/* In the course of development of the MPEG-4 standard. This software       */
/* module is an implementation of a part of one or more MPEG-4 tools as     */
/* specified by the MPEG-4 standard.                                        */
/*                                                                          */
/* The copyright of this software belongs to ISO/IEC. ISO/IEC gives use     */
/* of the MPEG-4 standard free license to use this  software module or      */
/* modifications thereof for hardware or software products claiming         */
/* conformance to the MPEG-4 standard.                                      */
/*                                                                          */
/* Those intending to use this software module in hardware or software      */
/* products are advised that use may infringe existing  patents. The        */
/* original developers of this software module and their companies, the     */
/* subsequent editors and their companies, and ISO/IEC have no liability    */
/* and ISO/IEC have no liability for use of this software module or         */
/* modification thereof in an implementation.                               */
/*                                                                          */
/* Permission is granted to MPEG memebers to use, copy, modify,             */
/* and distribute the software modules ( or portions thereof )              */
/* for standardization activity within ISO/IEC JTC1/SC29/WG11.              */
/*                                                                          */
/* Copyright (C) 1998  Sarnoff Coporation and Texas Instruments             */ 
/****************************************************************************/

/************************************************************/
/*     Sarnoff Very Low Bit Rate Still Image Coder          */
/*     Copyright 1995, 1996, 1997, 1998 Sarnoff Corporation */
/************************************************************/

/***********************************************/
/* Filename: comp_en_de.c                      */
/* Author: Bing-Bing Chai                      */
/* Date: January 9, 1998                       */
/*                                             */
/* Description:                                */
/*    This program compare the two files that  */
/*    contains the following information aboout*/
/*    an image:                                */
/*      h, w, q_val, type, state, ac_model     */
/*    The two files will be considered as      */
/*    having the same info as long as the first*/
/*    three or four items are the same         */
/***********************************************/

#include <stdio.h>

static void ERROR(char *msg)
{
  printf("%s\n",msg);
  exit(1);
}


main(int argc,char **argv)
{
  register int i,count=0;
  int d1,d2;
  FILE *fp1,*fp2;

  if(argc !=3)
    ERROR("Usage: comp_en_de file1 file2");

  fp1=fopen(argv[1],"r");
  if(fp1 == NULL)
    ERROR("cannot open the first file");
  fp2=fopen(argv[2],"r");
  if(fp2 == NULL)
    ERROR("cannot open the second file");

  while(!feof(fp1) && !feof(fp2)){
    count++;
    for(i=0;i<3;i++){
      fscanf(fp1,"%d",&d1); fgetc(fp1);
      fscanf(fp2,"%d",&d2); fgetc(fp2);
      /* printf("%d %d ",d1,d2); */
      if(d1 != d2){
        printf("Find difference at line %d\n",count);
        exit(1);
      }
    }
    fscanf(fp1,"%d",&d1);
    fscanf(fp2,"%d",&d2);

    fscanf(fp1,"%d",&d1);
    fscanf(fp2,"%d",&d2);
    if(d1==2)
      if(d1 != d2){
        printf("Find difference at line %d\n",count);
        exit(1);
      }

    for(i=0;i<1;i++){
      fscanf(fp1,"%d",&d1);
      fscanf(fp2,"%d",&d2);
    /* printf("%d %d\n",d1,d2); */
    }
  }

  if(!feof(fp1) && !feof(fp2))
    printf("The two files are not of the same length\n");
  else
    printf("the two files are the same\n");
  fclose(fp1);
  fclose(fp2);
}
